##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

require 'spec_helper.rb'

describe 'Export' do
  it "can fetch" do
    @holodeck.mock(Twilio::Response.new(500, ''))

    expect {
      @client.preview.bulk_exports.exports('resource_type').fetch()
    }.to raise_exception(Twilio::REST::TwilioError)

    values = {}
    expect(
    @holodeck.has_request?(Holodeck::Request.new(
        method: 'get',
        url: 'https://preview.twilio.com/BulkExports/Exports/resource_type',
    ))).to eq(true)
  end

  it "receives fetch responses" do
    @holodeck.mock(Twilio::Response.new(
        200,
      %q[
      {
          "resource_type": "Calls",
          "url": "https://preview.twilio.com/BulkExports/Exports/Calls",
          "links": {
              "days": "https://preview.twilio.com/BulkExports/Exports/Calls/Days"
          }
      }
      ]
    ))

    actual = @client.preview.bulk_exports.exports('resource_type').fetch()

    expect(actual).to_not eq(nil)
  end
end